

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.learn.nn.d2o_mask_factory &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../../index.html"/>
        <link rel="up" title="Module code" href="../../../index.html"/> 

  
  <script src="../../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.learn.nn.d2o_mask_factory</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.learn.nn.d2o_mask_factory</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">masks</span> <span class="kn">import</span> <span class="n">IndexMask</span>

<div class="viewcode-block" id="d2oMaskFactory"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.d2o_mask_factory.d2oMaskFactory">[docs]</a><span class="k">class</span> <span class="nc">d2oMaskFactory</span><span class="p">:</span>
  <span class="sd">&quot;&quot;&quot; Mask generator designed based on results from research on d2o timeseries &quot;&quot;&quot;</span>
  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">target_mask</span><span class="p">,</span> <span class="n">cutoff</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">req_cols</span><span class="o">=</span><span class="p">[],</span> <span class="n">forecasting_cols</span><span class="o">=</span><span class="p">[]):</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">req_cols</span> <span class="o">=</span> <span class="n">req_cols</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">forecasting_cols</span> <span class="o">=</span> <span class="n">forecasting_cols</span>

    <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">req_cols</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
      <span class="k">if</span> <span class="p">(</span><span class="ow">not</span> <span class="nb">all</span><span class="p">([</span><span class="n">x</span> <span class="ow">in</span> <span class="n">df</span><span class="o">.</span><span class="n">columns</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">req_cols</span><span class="p">])):</span>
        <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;Missing required columns </span><span class="si">%s</span><span class="s2"> in dataframe&quot;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">req_cols</span><span class="p">)</span>

    <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">target_mask</span><span class="o">.</span><span class="n">masks</span><span class="o">.</span><span class="n">keys</span><span class="p">())</span> <span class="o">!=</span> <span class="mi">1</span><span class="p">):</span>
      <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;Expected one dimensional target mask, got mask with length = </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="nb">len</span><span class="p">(</span><span class="n">target_mask</span><span class="o">.</span><span class="n">masks</span><span class="o">.</span><span class="n">keys</span><span class="p">()))</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">df</span> <span class="o">=</span> <span class="n">df</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">target_mask</span> <span class="o">=</span> <span class="n">target_mask</span> <span class="c1"># The target_mask = [i+t, i+t1, i+t2, ..., i+tn]</span>

    <span class="c1"># This implementation only supports one variable/column</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">target_column</span> <span class="o">=</span> <span class="n">target_mask</span><span class="o">.</span><span class="n">masks</span><span class="o">.</span><span class="n">keys</span><span class="p">()[</span><span class="mi">0</span><span class="p">]</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span> <span class="o">=</span> <span class="n">target_mask</span><span class="o">.</span><span class="n">masks</span><span class="o">.</span><span class="n">values</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">][:</span><span class="n">cutoff</span><span class="p">]</span>

<div class="viewcode-block" id="d2oMaskFactory.input_mask"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.d2o_mask_factory.d2oMaskFactory.input_mask">[docs]</a>  <span class="k">def</span> <span class="nf">input_mask</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">padding</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; The logic is as follows:</span>
<span class="sd">          For index i (in the dataframe); The input_mask = [i, i-t1, i-t2, ..., i-tn]</span>
<span class="sd">          Where t is an element in the the target_mask</span>

<span class="sd">    NOTE: In addition to this we manually add a few lag periods (i-t&#39;s)</span>
<span class="sd">          1. We manually add i-365.</span>
<span class="sd">          2. The columns [&#39;Total_RN&#39;, &#39;Total_RV&#39;] are added to the input mask, with the same</span>
<span class="sd">             lags as the target variable</span>
<span class="sd">          3. Padding is added to include more data around the relevant lag periods</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="c1"># Flip the target mask</span>
    <span class="c1"># TODO: Remove hardcoded split (due to performance issues) ..[:len(self.target_indices)/2]</span>
    <span class="n">t_minuses</span> <span class="o">=</span> <span class="p">(</span><span class="o">-</span><span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">)</span><span class="o">.</span><span class="n">tolist</span><span class="p">()[:</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">)]</span> <span class="o">+</span> <span class="p">[</span><span class="o">-</span><span class="mi">365</span><span class="p">]</span>

    <span class="c1"># Add padding (in reverse order [::-1] as it makes more sense for negative numbers)</span>
    <span class="n">t_minuses</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="n">t</span><span class="o">-</span><span class="n">padding</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="n">t</span><span class="o">+</span><span class="n">padding</span><span class="o">-</span><span class="mi">1</span><span class="o">+</span><span class="mi">1</span><span class="p">)[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">t_minuses</span><span class="p">])</span>
    <span class="n">t_minuses</span> <span class="o">=</span> <span class="n">t_minuses</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span> <span class="c1"># We want a serialized vector</span>

    <span class="c1"># Add index = 0</span>
    <span class="n">t_minuses</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">t_minuses</span><span class="o">.</span><span class="n">tolist</span><span class="p">())</span>

    <span class="c1"># A little check to make sure we don&#39;t have any target indices in the input mask</span>
    <span class="k">if</span> <span class="p">(</span><span class="nb">any</span><span class="p">([</span><span class="n">x</span> <span class="ow">in</span> <span class="n">t_minuses</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">])):</span>
      <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;Target indices in input mask&quot;</span><span class="p">)</span>

    <span class="c1"># Create the final mask (target column + Total_RN and Total_RV)</span>
    <span class="n">input_mask_dict</span> <span class="o">=</span> <span class="p">{</span><span class="n">key</span><span class="p">:[</span><span class="n">t_minuses</span><span class="p">]</span> <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">target_column</span><span class="p">]</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">req_cols</span><span class="p">}</span>

    <span class="c1"># Add forecasting values</span>
    <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">forecasting_cols</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
      <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">forecasting_cols</span><span class="p">:</span>
        <span class="n">input_mask_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="mi">0</span><span class="p">])]</span>

    <span class="k">return</span> <span class="n">IndexMask</span><span class="p">(</span><span class="n">input_mask_dict</span><span class="p">)</span></div></div>

<span class="c1"># # Some tests</span>
<span class="c1"># import unittest</span>
<span class="c1"># class d2oMaskFactoryTest(unittest.TestCase):</span>
<span class="c1">#   import pandas as pd</span>

<span class="c1">#   df = pd.DataFrame.from_dict({&#39;Total_RV&#39;:range(0,10000), &#39;Total_RN&#39;:range(0,10000), &#39;Restaurant&#39;:range(0,10000)})</span>
<span class="c1">#   targets = [6,13,20,27,34,41]</span>
<span class="c1">#   target_mask = IndexMask({&#39;Restaurant&#39;:[np.array(targets)]})</span>

<span class="c1">#   padding = 2</span>
<span class="c1">#   input_mask = d2oMaskFactory(df, target_mask).input_mask(padding=padding)</span>
<span class="c1">#   num_input_variables = len(input_mask.masks.keys())</span>

<span class="c1">#   def test_numvars(self):</span>
<span class="c1">#     &quot;&quot;&quot; Number of input variables &quot;&quot;&quot;</span>
<span class="c1">#     self.assertTrue(self.num_input_variables == 3)</span>

<span class="c1">#   def test_len_input(self):</span>
<span class="c1">#     n_target_mask = len(self.target_mask) + 1</span>
<span class="c1">#     padding = self.padding*2 + 1</span>
<span class="c1">#     n_input_variables = self.num_input_variables</span>
<span class="c1">#     n_zeros = 3</span>

<span class="c1">#     lhs = len(self.input_mask)</span>
<span class="c1">#     rhs = n_target_mask*padding*n_input_variables+n_zeros</span>

<span class="c1">#     self.assertTrue(lhs == rhs)</span>

<span class="c1">#   def test_index_leaks(self):</span>
<span class="c1">#     &quot;&quot;&quot; Make sure target indices don&#39;t exist in the input mask &quot;&quot;&quot;</span>
<span class="c1">#     self.assertFalse(any([x in np.concatenate(self.input_mask.masks.values()).reshape(-1) for x in self.targets]))</span>

<span class="c1"># if __name__ == &quot;__main__&quot;:</span>
<span class="c1">#   unittest.main()</span>
</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>